---
category: [Administration & Integrations, Administration & Integrations/Workday API, Platform and Product Extensions, Platform and Product Extensions/Integration, Administration & Integrations/Custom Integrations & Apps, Platform and Product Extensions/Workday Extend]
keyword: [Extend, Integrate, Business Process, BP, Extend BP, Extend Pro, Subprocess, Orchestration, Model Component BP, BP Event]
nav: wcp_docs
parent_url: /wcp_docs/
title: Submit Event Steps REST API
layout: subsection
---

## <a id="section_overview"></a>Submit Event Steps REST API for Extend Business Processes

The `POST /eventSteps/{ID}/submit` endpoint of the Event Steps REST API in the `businessProcess` REST service enables Extend apps to:

-   Submit an event step of an Extend business process.
-   Advance to the next step in the business process.


## <a id="section_url_base_path"></a>URL

```
https://{basePath}/businessProcess/{version}/eventSteps/{eventStepId}/submit
```

where:

-   `{basePath}`: The regional URL base path. See [Reference: Workday Extend API Gateways and Authorization Base URLs](/wcp_docs/dlh1653340161856.html).
-   `{version}` Currently v1.
-   `{eventStepId}` The Workday ID of the event step to submit. See the <i>Submitting the Event Step</i> section.


<b>Note:</b> This `POST /eventSteps/{ID}/submit` endpoint is only available through the Extend API Gateway. You can’t use the tenant-based URL with this endpoint.

<b>HTTP Method</b> : POST

<b>Content-Type</b> : application/json

<b>Request Body</b> :

<table><thead><tr><th>Field</th><th>Description</th></tr></thead><tbody><tr><td>comment</td><td>Optional comment about the event step.</td></tr></tbody></table><br/>

<b>Response</b> :

<table><thead><tr><th>Field</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>The event step ID.</td></tr><tr><td>descriptor</td><td>The name of the event step.</td></tr><tr><td>stepAction</td><td>Contains the “Submitted” id and descriptor.</td></tr></tbody></table><br/>

<b>Note:</b> The `POST /eventSteps/{ID}/submit` endpoint only applies to Extend business processes. You can’t use this endpoint with Workday-delivered business processes.

## <a id="section_prerequisites"></a>Prerequisites

-   The current business process is an Extend business process. You can’t use this endpoint with Workday-delivered business processes.
-   The current user is awaiting action on the step.
-   The current event step is an Initiation Step or Action Step.


## <a id="section_submitting_step"></a>Submitting the Event Step

To advance the in-progress step to the next step in the Extend business process event step:

1.  Ensure that the processing user is the person awaiting action on the event step.
2.  Update any targetBusinessObject details using the Extend Business Object REST API.

    ```
    PUT or PATCH https://{basePath}/apps/{appId}/v1/{defaultCollectionName}
    ```

3.  Submit the event step using the Event Steps REST API.

    ```
    POST https://{basePath}/businessProcess}/v1/eventSteps/"<% queryParams.eventStepId %>"/submit
     
    ```

    If you’re submitting this endpoint from the action page that’s routed to the inbox, the `<% queryParams.eventStepId %>` automatically contains the correct eventStep id.

    If you’re submitting the event step outside the context of the page route in the inbox, you can use the `GET /events/{eventId}/inProgressSteps` to get the eventStepId.


This example submits a sample in-progress event step with the specified Workday ID.

Sample request:

```
POST /eventSteps/49367bfa904f9001addc170d7fad0000/submit
```

Request body must be empty:

```
{ }
```

Sample response:

```
{
  "id": "49367bfa904f9001addc170d7fad0000",
  "descriptor": “Approval by Manager”,
  "stepAction" :  {
    "descriptor": "Submitted”
    "id": "d9e4223e446c11de98360015c5e6daf6",
  }
}
```

